<script lang="ts" setup>
import { usePromotionStore } from '@/stores/Promotion'
import PromotionCard from './PromotionCard.vue'
import type { Promotion } from '@/types/Promotion'
import type { PromotionItem } from '@/types/PromotionItem'
import { ref } from 'vue'
import PromotionSearchBar from './PromotionSearchBar.vue'

const promotionStore = usePromotionStore()
</script>
<template>
  <v-btn
    prepend-icon="mdi-ticket-percent"
    @click="(promotionStore.showPromotiondialog = true), (promotionStore.promotionDialog = true)"
    block
    >Use the Promotion</v-btn
  >

  <!-- Promotion dialog สตาท -->
  <v-dialog
    v-model="promotionStore.promotionDialog"
    persistent
    min-width="500"
    max-width="700"
    :class="[promotionStore.showPromotiondialog ? '' : 'hidden-dialog']"
  >
    <v-card color="rgba(114, 87, 42, 1)" min-height="50" class="pa-4">
      <PromotionSearchBar min-width="400" />
    </v-card>
    <v-sheet color="rgba(180, 143, 81, 1)">
      <v-list style="height: 500px; overflow-y: scroll; background-color: rgba(180, 143, 81, 1)">
        <template :key="promotion.id" v-for="promotion in promotionStore.searchfilteredPromotions">
          <PromotionCard :promotion="promotion"></PromotionCard>
        </template>
      </v-list>

      <!-- justify will make it to the end -->
      <v-card-actions class="justify-end" style="background-color: rgba(114, 87, 42, 1)">
        <v-btn
          @click="(promotionStore.showPromotiondialog = false), (promotionStore.searchQuery = '')"
          size="x-large"
          variant="elevated"
          >Cancel</v-btn
        >
        <v-btn
          @click="promotionStore.promotionConfirmDialog = true"
          size="x-large"
          variant="elevated"
          >Agree</v-btn
        >
        <!-- this is confirm dialog -->
        <v-dialog v-model="promotionStore.promotionConfirmDialog" persistent width="auto">
          <v-card color="rgba(114, 87, 42, 1)">
            <v-card-title> Confirm? </v-card-title>
            <v-card-text> Do you want to proceed? </v-card-text>
            <v-card-actions>
              <!-- put the space to make the button to the foot of dialog -->
              <v-spacer></v-spacer>
              <v-btn
                @click="promotionStore.promotionConfirmDialog = false"
                append-icon="mdi-cancel"
              >
                Cancel
              </v-btn>
              <v-btn
                @click="
                  (promotionStore.promotionDialog = false),
                    (promotionStore.promotionConfirmDialog = false)
                "
                append-icon="mdi-check-circle"
              >
                Yes
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-card-actions>
    </v-sheet>
  </v-dialog>
</template>
<style>
.hidden-dialog {
  display: none;
}
</style>
